const fs = require('fs')
const { join } = require('path')
const download = require('download')
const osTmpdir = require('os-tmpdir')
const tarStreamToArray = require('./')

const url = 'http://codeload.github.com/tankywoo/dotfiles/legacy.tar.gz/master'
const tempdir = osTmpdir()
const filename = 'repo.tar'
const path = join(tempdir, filename)

beforeAll(async done => {
  await download(url, tempdir, { filename }).then(() => {
    done()
  })
})

describe('After calling tarStreamToArray with a stream read from a tar file', () => {
  it('should return a promise that resolves with an array as the first argument', async done => {
    const repoStream = fs.createReadStream(path)
    await tarStreamToArray(repoStream).then(result => {
      expect(Array.isArray(result)).toBe(true)
      done()
    })
  })
})

afterAll(async done => {
  await fs.unlink(path, err => {
    if (err) throw err
    done()
  })
})
